<!-- markdownlint-disable -->
<h1 align="center">
    best-of-ml-rust
    <br>
</h1>

<p align="center">
    <strong>🏆&nbsp; A ranked list of awesome machine learning Rust libraries.</strong>
</p>

<p align="center">
    <a href="https://best-of.org" title="Best-of Badge"><img src="http://bit.ly/3o3EHNN"></a>
    <a href="#Contents" title="Project Count"><img src="https://img.shields.io/badge/projects-180-blue.svg?color=5ac4bf"></a>
    <a href="#Contribution" title="Contributions are welcome"><img src="https://img.shields.io/badge/contributions-welcome-green.svg"></a>
    <a href="https://github.com/e-tony/best-of-ml-rust/releases" title="Best-of Updates"><img src="https://img.shields.io/github/release-date/e-tony/best-of-ml-rust?color=green&label=updated"></a>
</p>

This curated list contains 180 awesome open-source projects with a total of 150K stars grouped into 8 categories. All projects are ranked by a project-quality score, which is calculated based on various metrics automatically collected from GitHub and different package managers. If you like to add or update projects, feel free to open an [issue](https://github.com/e-tony/best-of-ml-rust/issues/new/choose), submit a [pull request](https://github.com/e-tony/best-of-ml-rust/pulls), or directly edit the [projects.yaml](https://github.com/e-tony/best-of-ml-rust/edit/main/projects.yaml). Contributions are very welcome!

> 🧙‍♂️  Discover other [best-of lists](https://best-of.org) or [create your own](https://github.com/best-of-lists/best-of/blob/main/create-best-of-list.md).

## Contents

- [Machine Learning Frameworks](#machine-learning-frameworks) _80 projects_
- [Text Data & NLP](#text-data--nlp) _53 projects_
- [Image Data](#image-data) _10 projects_
- [Data Loading & Extraction](#data-loading--extraction) _15 projects_
- [Graph Data](#graph-data) _4 projects_
- [Model Interpretability](#model-interpretability) _1 projects_
- [MLOps](#mlops) _1 projects_
- [Applications](#applications) _11 projects_

## Explanation
- 🥇🥈🥉&nbsp; Combined project-quality score
- ⭐️&nbsp; Star count from GitHub
- 🐣&nbsp; New project _(less than 6 months old)_
- 💤&nbsp; Inactive project _(6 months no activity)_
- 💀&nbsp; Dead project _(12 months no activity)_
- 📈📉&nbsp; Project is trending up or down
- ➕&nbsp; Project was recently added
- ❗️&nbsp; Warning _(e.g. missing/risky license)_
- 👨‍💻&nbsp; Contributors count from GitHub
- 🔀&nbsp; Fork count from GitHub
- 📋&nbsp; Issue count from GitHub
- ⏱️&nbsp; Last update timestamp on package manager
- 📥&nbsp; Download count from package manager
- 📦&nbsp; Number of dependent projects
- <img src="🎁" style="display:inline;" width="13" height="13">&nbsp; A binding for another project.

<br>

## Machine Learning Frameworks

<a href="#contents"><img align="right" width="15" height="15" src="https://git.io/JtehR" alt="Back to top"></a>

_General-purpose machine learning and deep learning frameworks._

<details><summary><b><a href="https://github.com/rusoto/rusoto">rusoto</a></b> (🥇20 ·  ⭐ 2.4K) - AWS SDK for Rust. <code><a href="http://bit.ly/34MBwT8">MIT</a></code></summary>

- [GitHub](https://github.com/rusoto/rusoto) (👨‍💻 180 · 🔀 380 · 📋 880 - 23% open · ⏱️ 26.07.2021):

	```
	git clone https://github.com/rusoto/rusoto
	```
</details>
<details><summary><b><a href="https://github.com/apache/tvm">tvm</a></b> (🥇18 ·  ⭐ 7.2K) - Open deep learning compiler stack for cpu, gpu and specialized.. <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code> <code><img src="🎁" style="display:inline;" width="13" height="13"></code></summary>

- [GitHub](https://github.com/apache/tvm) (👨‍💻 630 · 🔀 2.1K · 📥 720 · 📋 2K - 9% open · ⏱️ 03.10.2021):

	```
	git clone https://github.com/apache/tvm
	```
</details>
<details><summary><b><a href="https://github.com/dimforge/nalgebra">nalgebra</a></b> (🥇18 ·  ⭐ 2.3K) - Linear algebra library for Rust. <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code></summary>

- [GitHub](https://github.com/dimforge/nalgebra) (👨‍💻 150 · 🔀 290 · 📋 490 - 38% open · ⏱️ 04.10.2021):

	```
	git clone https://github.com/dimforge/nalgebra
	```
</details>
<details><summary><b><a href="https://github.com/statrs-dev/statrs">statrs</a></b> (🥇17 ·  ⭐ 280) - Statistical computation library for Rust. <code><a href="http://bit.ly/34MBwT8">MIT</a></code></summary>

- [GitHub](https://github.com/statrs-dev/statrs) (👨‍💻 22 · 🔀 38 · 📋 97 - 20% open · ⏱️ 01.09.2021):

	```
	git clone https://github.com/boxtown/statrs
	```
</details>
<details><summary><b><a href="https://github.com/tensorflow/rust">rust</a></b> (🥇16 ·  ⭐ 3.3K) - Rust language bindings for TensorFlow. <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code> <code><img src="🎁" style="display:inline;" width="13" height="13"></code></summary>

- [GitHub](https://github.com/tensorflow/rust) (👨‍💻 42 · 🔀 270 · 📋 140 - 25% open · ⏱️ 26.09.2021):

	```
	git clone https://github.com/tensorflow/rust
	```
</details>
<details><summary><b><a href="https://github.com/xaynetwork/xaynet">xaynet</a></b> (🥇16 ·  ⭐ 150) - Xaynet represents an agnostic Federated Machine Learning framework to.. <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code></summary>

- [GitHub](https://github.com/xaynetwork/xaynet) (👨‍💻 28 · 🔀 19 · 📋 30 - 10% open · ⏱️ 27.09.2021):

	```
	git clone https://github.com/xaynetwork/xaynet
	```
</details>
<details><summary><b><a href="https://github.com/PyO3/rust-numpy">rust-numpy</a></b> (🥇15 ·  ⭐ 510) - PyO3-based Rust binding of NumPy C-API. <code><a href="http://bit.ly/3rqEWVr">BSD-2</a></code></summary>

- [GitHub](https://github.com/PyO3/rust-numpy) (👨‍💻 30 · 🔀 64 · 📋 71 - 22% open · ⏱️ 14.09.2021):

	```
	git clone https://github.com/PyO3/rust-numpy
	```
</details>
<details><summary><b><a href="https://github.com/granne/granne">granne</a></b> (🥇15 ·  ⭐ 250) - Graph-based Approximate Nearest Neighbor Search. <code><a href="http://bit.ly/34MBwT8">MIT</a></code></summary>

- [GitHub](https://github.com/granne/granne) (👨‍💻 6 · 🔀 22 · 📋 14 - 42% open · ⏱️ 19.05.2021):

	```
	git clone https://github.com/granne/granne
	```
</details>
<details><summary><b><a href="https://github.com/ballista-compute/ballista">ballista</a></b> (🥈14 ·  ⭐ 2.3K) - Distributed compute platform implemented in Rust, and powered by.. <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code></summary>

- [GitHub](https://github.com/ballista-compute/ballista) (👨‍💻 37 · 🔀 140 · ⏱️ 20.04.2021):

	```
	git clone https://github.com/ballista-compute/ballista
	```
</details>
<details><summary><b><a href="https://github.com/raskr/rust-autograd">rust-autograd</a></b> (🥈13 ·  ⭐ 330) - Tensors and differentiable operations (like TensorFlow) in Rust. <code><a href="http://bit.ly/34MBwT8">MIT</a></code></summary>

- [GitHub](https://github.com/raskr/rust-autograd) (👨‍💻 13 · 🔀 23 · 📋 28 - 21% open · ⏱️ 07.08.2021):

	```
	git clone https://github.com/raskr/rust-autograd
	```
</details>
<details><summary><b><a href="https://github.com/Azure/azure-sdk-for-rust">azure-sdk-for-rust</a></b> (🥈12 ·  ⭐ 160) - This repository is for active development of the.. <code><a href="http://bit.ly/34MBwT8">MIT</a></code> <code><img src="🎁" style="display:inline;" width="13" height="13"></code></summary>

- [GitHub](https://github.com/Azure/azure-sdk-for-rust) (👨‍💻 65 · 🔀 79 · 📋 160 - 43% open · ⏱️ 04.10.2021):

	```
	git clone https://github.com/Azure/azure-sdk-for-rust
	```
</details>
<details><summary><b><a href="https://github.com/hora-search/hora">hora</a></b> (🥈11 ·  ⭐ 2.1K · 🐣) - efficient approximate nearest neighbor search algorithm collections.. <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code></summary>

- [GitHub](https://github.com/hora-search/hora) (👨‍💻 5 · 🔀 33 · 📋 20 - 55% open · ⏱️ 14.09.2021):

	```
	git clone https://github.com/hora-search/hora
	```
</details>
<details><summary><b><a href="https://github.com/smartcorelib/smartcore">smartcore</a></b> (🥉10 ·  ⭐ 180) - SmartCore is a comprehensive library for machine learning and.. <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code></summary>

- [GitHub](https://github.com/smartcorelib/smartcore) (👨‍💻 14 · 🔀 20 · 📋 46 - 58% open · ⏱️ 29.04.2021):

	```
	git clone https://github.com/smartcorelib/smartcore
	```
</details>
<details><summary><b><a href="https://github.com/bilal2vec/L2">L2</a></b> (🥉10 ·  ⭐ 140 · 💤) - l2 is a fast, Pytorch-style Tensor+Autograd library written in Rust. <code><a href="http://bit.ly/34MBwT8">MIT</a></code></summary>

- [GitHub](https://github.com/bilal2vec/L2) (🔀 15 · ⏱️ 04.02.2021):

	```
	git clone https://github.com/bilal2vec/L2
	```
</details>
<details><summary><b><a href="https://github.com/vertexclique/orkhon">orkhon</a></b> (🥉10 ·  ⭐ 110 · 💤) - Orkhon: ML Inference Framework and Server Runtime. <code><a href="http://bit.ly/34MBwT8">MIT</a></code></summary>

- [GitHub](https://github.com/vertexclique/orkhon) (🔀 3 · 📋 7 - 57% open · ⏱️ 01.02.2021):

	```
	git clone https://github.com/vertexclique/orkhon
	```
</details>
<details><summary>Show 65 hidden projects...</summary>

- <b><a href="https://github.com/weld-project/weld">weld</a></b> (🥇16 ·  ⭐ 2.7K · 💀) - High-performance runtime for data analytics applications. <code><a href="http://bit.ly/3aKzpTv">BSD-3</a></code>
- <b><a href="https://github.com/sonos/tract">tract</a></b> (🥇15 ·  ⭐ 1.1K) - Tiny, no-nonsense, self-contained, Tensorflow and ONNX inference. <code>❗Unlicensed</code>
- <b><a href="https://github.com/rust-ml/linfa">linfa</a></b> (🥈14 ·  ⭐ 1.2K · 📉) - A Rust machine learning framework. <code>❗Unlicensed</code>
- <b><a href="https://github.com/substantic/rain">rain</a></b> (🥈14 ·  ⭐ 660 · 💀) - Framework for large distributed pipelines. <code><a href="http://bit.ly/34MBwT8">MIT</a></code>
- <b><a href="https://github.com/Synerise/cleora">cleora</a></b> (🥈14 ·  ⭐ 340) - Cleora AI is a general-purpose model for efficient, scalable.. <code>❗Unlicensed</code>
- <b><a href="https://github.com/LaurentMazare/tch-rs">tch-rs</a></b> (🥈13 ·  ⭐ 1.2K) - Rust bindings for the C++ api of PyTorch. <code>❗Unlicensed</code> <code><img src="🎁" style="display:inline;" width="13" height="13"></code>
- <b><a href="https://github.com/AtheMathmo/rusty-machine">rusty-machine</a></b> (🥈13 ·  ⭐ 1.2K · 💀) - Machine Learning library for Rust. <code><a href="http://bit.ly/34MBwT8">MIT</a></code>
- <b><a href="https://github.com/spearow/juice">juice</a></b> (🥈13 ·  ⭐ 810) - The Hacker's Machine Learning Engine. <code>❗Unlicensed</code>
- <b><a href="https://github.com/maciejkula/rustlearn">rustlearn</a></b> (🥈13 ·  ⭐ 500 · 💀) - Machine learning crate for Rust. <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code>
- <b><a href="https://github.com/autumnai/leaf">leaf</a></b> (🥈12 ·  ⭐ 5.5K · 💀) - Open Machine Intelligence Framework for Hackers. (GPU/CPU). <code>❗Unlicensed</code>
- <b><a href="https://github.com/google/evcxr">evcxr</a></b> (🥈12 ·  ⭐ 2.7K) -  <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code>
- <b><a href="https://github.com/wsmoses/Enzyme">Enzyme</a></b> (🥈12 ·  ⭐ 530) - High-performance automatic differentiation of LLVM. <code>❗Unlicensed</code>
- <b><a href="https://github.com/milesgranger/gap_statistic">gap_statistic</a></b> (🥈12 ·  ⭐ 110 · 💤) - Dynamically get the suggested clusters in the data.. <code>❗Unlicensed</code>
- <b><a href="https://github.com/milesgranger/pyrus-cramjam">pyrus-cramjam</a></b> (🥈12 ·  ⭐ 27) - Thin Python wrapper to de/compression algorithms in Rust -.. <code><a href="http://bit.ly/34MBwT8">MIT</a></code>
- <b><a href="https://github.com/argmin-rs/argmin">argmin</a></b> (🥈11 ·  ⭐ 320) - Mathematical optimization in pure Rust. <code>❗Unlicensed</code>
- <b><a href="https://github.com/vbarrielle/sprs">sprs</a></b> (🥈11 ·  ⭐ 250) - sparse linear algebra library for rust. <code>❗Unlicensed</code>
- <b><a href="https://github.com/Axect/Peroxide">Peroxide</a></b> (🥈11 ·  ⭐ 240) - Rust numeric library with R, MATLAB & Python syntax. <code>❗Unlicensed</code>
- <b><a href="https://github.com/tspooner/rsrl">rsrl</a></b> (🥈11 ·  ⭐ 110 · 💀) - A fast, safe and easy to use reinforcement learning framework in Rust. <code><a href="http://bit.ly/34MBwT8">MIT</a></code>
- <b><a href="https://github.com/Enet4/faiss-rs">faiss-rs</a></b> (🥈11 ·  ⭐ 49) - Rust language bindings for Faiss. <code>❗Unlicensed</code> <code><img src="🎁" style="display:inline;" width="13" height="13"></code>
- <b><a href="https://github.com/MrRobb/gym-rs">gym-rs</a></b> (🥈11 ·  ⭐ 36 · 💀) - OpenAI Gym bindings for Rust. <code><a href="http://bit.ly/34MBwT8">MIT</a></code> <code><img src="🎁" style="display:inline;" width="13" height="13"></code>
- <b><a href="https://github.com/jackm321/RustNN">RustNN</a></b> (🥉10 ·  ⭐ 300 · 💀) - A neural network crate. <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code>
- <b><a href="https://github.com/tedsta/deeplearn-rs">deeplearn-rs</a></b> (🥉10 ·  ⭐ 190 · 💀) - Neural networks in Rust. <code><a href="http://bit.ly/34MBwT8">MIT</a></code>
- <b><a href="https://github.com/nbigaouette/onnxruntime-rs">onnxruntime-rs</a></b> (🥉10 ·  ⭐ 87) - Rust wrapper for Microsoft's ONNX Runtime (version.. <code>❗Unlicensed</code> <code><img src="🎁" style="display:inline;" width="13" height="13"></code>
- <b><a href="https://github.com/torchrs/torchrs">torchrs</a></b> (🥉10 ·  ⭐ 74 · 💀) - Deep Learning in Rust with the PyTorch API. <code><a href="http://bit.ly/3rqEWVr">BSD-2</a></code> <code><img src="🎁" style="display:inline;" width="13" height="13"></code>
- <b><a href="https://github.com/ralfbiedert/ffsvm-rust">ffsvm-rust</a></b> (🥉10 ·  ⭐ 43 · 💀) - FFSVM stands for Really Fast Support Vector Machine. <code><a href="http://bit.ly/34MBwT8">MIT</a></code>
- <b><a href="https://github.com/milesgranger/black-jack">black-jack</a></b> (🥉10 ·  ⭐ 28) - DataFrame / Series data processing in Rust. <code><a href="http://bit.ly/2M0xdwT">❗️GPL-3.0</a></code>
- <b><a href="https://github.com/neuronika/neuronika">neuronika</a></b> (🥉9 ·  ⭐ 510) - Tensors and dynamic neural networks in pure Rust. <code><a href="http://bit.ly/3postzC">MPL-2.0</a></code>
- <b><a href="https://github.com/InstantDomain/instant-distance">instant-distance</a></b> (🥉9 ·  ⭐ 110) - Fast approximate nearest neighbor searching in Rust, based.. <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code>
- <b><a href="https://github.com/millardjn/alumina">alumina</a></b> (🥉9 ·  ⭐ 86) - A deep learning library for rust. <code>❗Unlicensed</code>
- <b><a href="https://github.com/bminixhofer/tractjs">tractjs</a></b> (🥉9 ·  ⭐ 58) - Run ONNX and TensorFlow inference in the browser. <code>❗Unlicensed</code>
- <b><a href="https://github.com/MikhailKravets/NeuroFlow">NeuroFlow</a></b> (🥉9 ·  ⭐ 54 · 💀) - Awesome deep learning crate. <code><a href="http://bit.ly/34MBwT8">MIT</a></code>
- <b><a href="https://github.com/boncheolgu/tflite-rs">tflite-rs</a></b> (🥉9 ·  ⭐ 48) -  <code>❗Unlicensed</code>
- <b><a href="https://github.com/daniel-e/rustml">rustml</a></b> (🥉9 ·  ⭐ 46 · 💀) - Machine learning in Rust. <code>❗Unlicensed</code>
- <b><a href="https://github.com/milanboers/rurel">rurel</a></b> (🥉9 ·  ⭐ 32 · 💤) - Flexible, reusable reinforcement learning (Q learning) implementation.. <code><a href="http://bit.ly/3postzC">MPL-2.0</a></code>
- <b><a href="https://github.com/avinashshenoy97/RusticSOM">RusticSOM</a></b> (🥉9 ·  ⭐ 22 · 💤) - Rust library for Self Organising Maps (SOM). <code><a href="http://bit.ly/34MBwT8">MIT</a></code>
- <b><a href="https://github.com/emakryo/rustdef">rustdef</a></b> (🥉9 ·  ⭐ 15) - Jupyter extension for rust. <code><a href="http://bit.ly/34MBwT8">MIT</a></code>
- <b><a href="https://github.com/mrhooray/kdtree-rs">kdtree-rs</a></b> (🥉8 ·  ⭐ 110) - K-dimensional tree in Rust for fast geospatial indexing and.. <code>❗Unlicensed</code>
- <b><a href="https://github.com/jramapuram/hal">hal</a></b> (🥉8 ·  ⭐ 79 · 💀) - Rust based Cross-GPU Machine Learning. <code><a href="http://bit.ly/34MBwT8">MIT</a></code>
- <b><a href="https://github.com/diffeo/kodama">kodama</a></b> (🥉8 ·  ⭐ 52 · 💤) - Fast hierarchical agglomerative clustering in Rust. <code><a href="http://bit.ly/34MBwT8">MIT</a></code>
- <b><a href="https://github.com/epwalsh/rust-dl-webserver">rust-dl-webserver</a></b> (🥉8 ·  ⭐ 21) - Example of serving deep learning models in Rust with.. <code>❗Unlicensed</code>
- <b><a href="https://github.com/charles-r-earp/autograph">autograph</a></b> (🥉7 ·  ⭐ 130) - Machine Learning Library for Rust. <code>❗Unlicensed</code>
- <b><a href="https://github.com/metamolecular/gamma">gamma</a></b> (🥉7 ·  ⭐ 110 · 💤) - A graph library for Rust. <code>❗Unlicensed</code>
- <b><a href="https://github.com/outbrain/fwumious_wabbit">fwumious_wabbit</a></b> (🥉7 ·  ⭐ 100) - Fwumious Wabbit, fast on-line machine learning toolkit.. <code>❗Unlicensed</code>
- <b><a href="https://github.com/rust-cv/hnsw">hnsw</a></b> (🥉7 ·  ⭐ 69) - HNSW ANN from the paper Efficient and robust approximate nearest neighbor search.. <code><a href="http://bit.ly/34MBwT8">MIT</a></code>
- <b><a href="https://github.com/frjnn/bhtsne">bhtsne</a></b> (🥉7 ·  ⭐ 23) - Barnes-Hut t-SNE implementation written in Rust. <code><a href="http://bit.ly/34MBwT8">MIT</a></code>
- <b><a href="https://github.com/messense/crfsuite-rs">crfsuite-rs</a></b> (🥉7 ·  ⭐ 16 · 💤) - Rust binding to crfsuite. <code><a href="http://bit.ly/34MBwT8">MIT</a></code>
- <b><a href="https://github.com/tomtung/craftml-rs">craftml-rs</a></b> (🥉7 ·  ⭐ 12 · 💀) - A Rust implementation of CRAFTML, an Efficient Clustering-based.. <code><a href="http://bit.ly/34MBwT8">MIT</a></code>
- <b><a href="https://github.com/CasperN/drug">drug</a></b> (🥉7 ·  ⭐ 10 · 💀) - Differentiable Rust Graphs (neural network library). <code><a href="http://bit.ly/34MBwT8">MIT</a></code>
- <b><a href="https://github.com/lerouxrgd/ngt-rs">ngt-rs</a></b> (🥉7 ·  ⭐ 10) - Rust wrappers for NGT approximate nearest neighbor search. <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code> <code><img src="🎁" style="display:inline;" width="13" height="13"></code>
- <b><a href="https://github.com/petabi/petal-clustering">petal-clustering</a></b> (🥉7 ·  ⭐ 7) - DBSCAN and OPTICS clustering algorithms. <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code>
- <b><a href="https://github.com/rust-cv/hwt">hwt</a></b> (🥉7 ·  ⭐ 6 · 💀) - Hamming Weight Tree from the paper Online Nearest Neighbor Search in Hamming.. <code><a href="http://bit.ly/34MBwT8">MIT</a></code>
- <b><a href="https://github.com/shadeMe/liblinear-rs">liblinear-rs</a></b> (🥉7 ·  ⭐ 5 · 💀) - Rust language bindings for the LIBLINEAR C/C++ library. <code><a href="http://bit.ly/34MBwT8">MIT</a></code> <code><img src="🎁" style="display:inline;" width="13" height="13"></code>
- <b><a href="https://github.com/liborty/rstats">rstats</a></b> (🥉7 ·  ⭐ 2) - Rust Statistics and Vector Algebra Library. <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code>
- <b><a href="https://github.com/philschmid/rust-hf-hub-loader">rust-hf-hub-loader</a></b> (🥉7 ·  ⭐ 2 · 🐣) -  <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code>
- <b><a href="https://github.com/c0dearm/mushin">mushin</a></b> (🥉6 ·  ⭐ 190 · 🐣) - Compile-time creation of neural networks. <code>❗Unlicensed</code>
- <b><a href="https://github.com/Robbepop/prophet">prophet</a></b> (🥉6 ·  ⭐ 40 · 💀) - A simple neural net implementation. <code>❗Unlicensed</code>
- <b><a href="https://github.com/JonathanWoollett-Light/cogent">cogent</a></b> (🥉6 ·  ⭐ 28 · 💤) - Simple neural network library for classification written in Rust. <code>❗Unlicensed</code>
- <b><a href="https://github.com/kornelski/vpsearch">vpsearch</a></b> (🥉6 ·  ⭐ 27 · 💤) - C library for finding nearest (most similar) element in a set. <code>❗Unlicensed</code>
- <b><a href="https://github.com/yurytsoy/revonet">revonet</a></b> (🥉6 ·  ⭐ 17 · 💀) - Rust implementation of real-coded GA for solving optimization.. <code><a href="http://bit.ly/2M0xdwT">❗️GPL-3.0</a></code>
- <b><a href="https://github.com/afck/fann-rs">fann-rs</a></b> (🥉6 ·  ⭐ 11 · 💀) - Rust wrapper for the Fast Artificial Neural Network library. <code><a href="http://bit.ly/37RvQcA">❗️LGPL-3.0</a></code>
- <b><a href="https://github.com/zenoxygen/bayespam">bayespam</a></b> (🥉6 ·  ⭐ 5 · 💤) - A simple bayesian spam classifier written in Rust. <code><a href="http://bit.ly/34MBwT8">MIT</a></code>
- <b><a href="https://github.com/epwalsh/batched-fn">batched-fn</a></b> (🥉6 ·  ⭐ 4) - Rust middleware for serving deep learning models with batched.. <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code>
- <b><a href="https://github.com/usamec/cntk-rs">cntk-rs</a></b> (🥉5 ·  ⭐ 20 · 💀) - Wrapper around Microsoft CNTK library. <code>❗Unlicensed</code>
- <b><a href="https://github.com/NivenT/REnforce">REnforce</a></b> (🥉5 ·  ⭐ 17 · 💀) - Reinforcement learning library written in Rust. <code>❗Unlicensed</code>
- <b><a href="https://github.com/finalfusion/reductive">reductive</a></b> (🥉5 ·  ⭐ 2) - Vector quantization. <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code>
</details>
<br>

## Text Data & NLP

<a href="#contents"><img align="right" width="15" height="15" src="https://git.io/JtehR" alt="Back to top"></a>

_Libraries for processing, cleaning, manipulating, and analyzing text data as well as for diverse NLP tasks._

<details><summary><b><a href="https://github.com/huggingface/tokenizers">tokenizers</a></b> (🥇21 ·  ⭐ 4.9K) - Fast State-of-the-Art Tokenizers optimized for Research and.. <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code></summary>

- [GitHub](https://github.com/huggingface/tokenizers) (👨‍💻 46 · 🔀 380 · 📦 38 · 📋 500 - 25% open · ⏱️ 08.09.2021):

	```
	git clone https://github.com/huggingface/tokenizers
	```
</details>
<details><summary><b><a href="https://github.com/pemistahl/grex">grex</a></b> (🥇17 ·  ⭐ 4.6K) - A command-line tool and library for generating regular expressions from.. <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code></summary>

- [GitHub](https://github.com/pemistahl/grex) (👨‍💻 6 · 🔀 100 · 📥 5.5K · 📋 36 - 8% open · ⏱️ 15.09.2021):

	```
	git clone https://github.com/pemistahl/grex
	```
</details>
<details><summary><b><a href="https://github.com/greyblake/whatlang-rs">whatlang-rs</a></b> (🥇15 ·  ⭐ 620) - Natural language detection library for Rust. Try demo online:.. <code><a href="http://bit.ly/34MBwT8">MIT</a></code></summary>

- [GitHub](https://github.com/greyblake/whatlang-rs) (👨‍💻 16 · 🔀 33 · 📋 41 - 7% open · ⏱️ 18.08.2021):

	```
	git clone https://github.com/greyblake/whatlang-rs
	```
</details>
<details><summary><b><a href="https://github.com/bminixhofer/nnsplit">nnsplit</a></b> (🥇14 ·  ⭐ 200) - Semantic text segmentation. For sentence boundary detection, compound.. <code><a href="http://bit.ly/34MBwT8">MIT</a></code></summary>

- [GitHub](https://github.com/bminixhofer/nnsplit) (👨‍💻 4 · 🔀 12 · 📦 3 · 📋 25 - 36% open · ⏱️ 23.07.2021):

	```
	git clone https://github.com/bminixhofer/nnsplit
	```
</details>
<details><summary><b><a href="https://github.com/lindera-morphology/lindera">lindera</a></b> (🥇14 ·  ⭐ 120) - A morphological analysis library. <code><a href="http://bit.ly/34MBwT8">MIT</a></code></summary>

- [GitHub](https://github.com/lindera-morphology/lindera) (👨‍💻 7 · 🔀 13 · 📥 5 · 📋 34 - 5% open · ⏱️ 30.09.2021):

	```
	git clone https://github.com/lindera-morphology/lindera
	```
</details>
<details><summary><b><a href="https://github.com/guillaume-be/rust-bert">rust-bert</a></b> (🥈13 ·  ⭐ 720) - Rust native ready-to-use NLP pipelines and transformer-based.. <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code></summary>

- [GitHub](https://github.com/guillaume-be/rust-bert) (👨‍💻 12 · 🔀 52 · 📋 57 - 17% open · ⏱️ 14.09.2021):

	```
	git clone https://github.com/guillaume-be/rust-bert
	```
</details>
<details><summary><b><a href="https://github.com/explosion/tokenizations">tokenizations</a></b> (🥈13 ·  ⭐ 100) - Robust and Fast tokenizations alignment library for Rust and.. <code><a href="http://bit.ly/34MBwT8">MIT</a></code></summary>

- [GitHub](https://github.com/explosion/tokenizations) (👨‍💻 3 · 🔀 9 · ⏱️ 27.09.2021):

	```
	git clone https://github.com/explosion/tokenizations
	```
</details>
<details><summary><b><a href="https://github.com/pemistahl/lingua-rs">lingua-rs</a></b> (🥈12 ·  ⭐ 300 · 📉) - The most accurate natural language detection library in the.. <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code></summary>

- [GitHub](https://github.com/pemistahl/lingua-rs) (👨‍💻 3 · 🔀 7 · 📋 15 - 46% open · ⏱️ 05.07.2021):

	```
	git clone https://github.com/pemistahl/lingua-rs
	```
</details>
<details><summary><b><a href="https://github.com/fancy-regex/fancy-regex">fancy-regex</a></b> (🥈10 ·  ⭐ 230) - Rust library for regular expressions using fancy features like look-.. <code><a href="http://bit.ly/34MBwT8">MIT</a></code></summary>

- [GitHub](https://github.com/fancy-regex/fancy-regex) (👨‍💻 16 · 🔀 18 · 📋 19 - 10% open · ⏱️ 13.08.2021):

	```
	git clone https://github.com/fancy-regex/fancy-regex
	```
</details>
<details><summary><b><a href="https://github.com/guillaume-be/rust-tokenizers">rust-tokenizers</a></b> (🥈10 ·  ⭐ 100) - Rust-tokenizer offers high-performance tokenizers for.. <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code></summary>

- [GitHub](https://github.com/guillaume-be/rust-tokenizers) (👨‍💻 2 · 🔀 12 · 📋 6 - 16% open · ⏱️ 15.09.2021):

	```
	git clone https://github.com/guillaume-be/rust-tokenizers
	```
</details>
<details><summary>Show 43 hidden projects...</summary>

- <b><a href="https://github.com/snipsco/snips-nlu-rs">snips-nlu-rs</a></b> (🥇14 ·  ⭐ 320 · 💀) - Snips NLU rust implementation. <code>❗Unlicensed</code>
- <b><a href="https://github.com/BurntSushi/aho-corasick">aho-corasick</a></b> (🥈12 ·  ⭐ 490) - A fast implementation of Aho-Corasick in Rust. <code>❗Unlicensed</code>
- <b><a href="https://github.com/bminixhofer/nlprule">nlprule</a></b> (🥈12 ·  ⭐ 360 · 📉) - A fast, low-resource Natural Language Processing and Text.. <code>❗Unlicensed</code>
- <b><a href="https://github.com/BurntSushi/memchr">memchr</a></b> (🥈12 ·  ⭐ 320) - Optimized string search routines for Rust. <code>❗Unlicensed</code>
- <b><a href="https://github.com/christophertrml/rs-natural">rs-natural</a></b> (🥈11 ·  ⭐ 200 · 💀) - Natural Language Processing for Rust. <code><a href="http://bit.ly/34MBwT8">MIT</a></code>
- <b><a href="https://github.com/snipsco/rustling-ontology">rustling-ontology</a></b> (🥈11 ·  ⭐ 120 · 💤) - Ontology for rustling. <code>❗Unlicensed</code>
- <b><a href="https://github.com/snipsco/rustling">rustling</a></b> (🥈11 ·  ⭐ 65 · 💀) - Rust implementation of Duckling. <code>❗Unlicensed</code> <code><img src="🎁" style="display:inline;" width="13" height="13"></code>
- <b><a href="https://github.com/snipsco/snips-nlu-ontology">snips-nlu-ontology</a></b> (🥈11 ·  ⭐ 55 · 💀) - Ontology of Snips NLU. <code>❗Unlicensed</code>
- <b><a href="https://github.com/finalfusion/finalfrontier">finalfrontier</a></b> (🥈10 ·  ⭐ 64) - Context-sensitive word embeddings with subwords. In Rust. <code>❗Unlicensed</code>
- <b><a href="https://github.com/finalfusion/finalfusion-rust">finalfusion-rust</a></b> (🥈10 ·  ⭐ 42) - finalfusion embeddings in Rust. <code>❗Unlicensed</code>
- <b><a href="https://github.com/oscar-corpus/ungoliant">ungoliant</a></b> (🥈10 ·  ⭐ 14) - The pipeline for the OSCAR corpus. <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code>
- <b><a href="https://github.com/CurrySoftware/rust-stemmers">rust-stemmers</a></b> (🥉9 ·  ⭐ 66) - A rust implementation of some popular snowball stemming algorithms. <code><a href="http://bit.ly/34MBwT8">MIT</a></code>
- <b><a href="https://github.com/danieldk/dpar">dpar</a></b> (🥉9 ·  ⭐ 41 · 💀) - Neural network transition-based dependency parser (in Rust). <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code>
- <b><a href="https://github.com/cpcdoy/rust-sbert">rust-sbert</a></b> (🥉9 ·  ⭐ 27 · 💤) - Rust port of sentence-transformers.. <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code>
- <b><a href="https://github.com/snipsco/gazetteer-entity-parser">gazetteer-entity-parser</a></b> (🥉9 ·  ⭐ 14 · 💀) - Rust library for parsing and resolving entity values.. <code>❗Unlicensed</code>
- <b><a href="https://github.com/snipsco/snips-nlu-parsers">snips-nlu-parsers</a></b> (🥉9 ·  ⭐ 13 · 💀) - Rust crate for entity parsing. <code>❗Unlicensed</code>
- <b><a href="https://github.com/rth/vtext">vtext</a></b> (🥉8 ·  ⭐ 120 · 💀) - Simple NLP in Rust with Python bindings. <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code>
- <b><a href="https://github.com/tantivy-search/levenshtein-automata">levenshtein-automata</a></b> (🥉8 ·  ⭐ 38) -  <code><a href="http://bit.ly/34MBwT8">MIT</a></code>
- <b><a href="https://github.com/messense/fasttext-rs">fasttext-rs</a></b> (🥉8 ·  ⭐ 32) - fastText Rust binding. <code>❗Unlicensed</code> <code><img src="🎁" style="display:inline;" width="13" height="13"></code>
- <b><a href="https://github.com/stickeritis/sticker">sticker</a></b> (🥉8 ·  ⭐ 26 · 💤) - Succeeded by SyntaxDot: https://github.com/tensordot/syntaxdot. <code>❗Unlicensed</code>
- <b><a href="https://github.com/pemistahl/chr">chr</a></b> (🥉8 ·  ⭐ 25 · 💤) - A command-line tool that gives information about Unicode characters. <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code>
- <b><a href="https://github.com/tensordot/syntaxdot">syntaxdot</a></b> (🥉8 ·  ⭐ 24) - Neural syntax annotator, supporting sequence labeling,.. <code>❗Unlicensed</code>
- <b><a href="https://github.com/DimaKudosh/word2vec">word2vec</a></b> (🥉8 ·  ⭐ 20 · 💀) - Rust interface to word2vec. <code><a href="http://bit.ly/34MBwT8">MIT</a></code>
- <b><a href="https://github.com/proycon/deepfrog">deepfrog</a></b> (🥉8 ·  ⭐ 15 · 📉) - An NLP-suite powered by deep learning. <code><a href="http://bit.ly/2M0xdwT">❗️GPL-3.0</a></code>
- <b><a href="https://github.com/google-research/deduplicate-text-datasets">deduplicate-text-datasets</a></b> (🥉7 ·  ⭐ 200 · 🐣) -  <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code>
- <b><a href="https://github.com/mklf/word2vec-rs">word2vec-rs</a></b> (🥉7 ·  ⭐ 30) - pure rust implemention of word2vec. <code>❗Unlicensed</code>
- <b><a href="https://github.com/vgel/treebender">treebender</a></b> (🥉7 ·  ⭐ 20) - A HDPSG-inspired symbolic natural language parser written in Rust. <code><a href="http://bit.ly/34MBwT8">MIT</a></code>
- <b><a href="https://github.com/sebpuetz/lumberjack">lumberjack</a></b> (🥉7 ·  ⭐ 11 · 💀) - Read and modify constituency trees in Rust. <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code>
- <b><a href="https://github.com/nakagami/awabi">awabi</a></b> (🥉7 ·  ⭐ 6) - A morphological analyzer using mecab dictionary. <code><a href="http://bit.ly/34MBwT8">MIT</a></code>
- <b><a href="https://github.com/danieldk/alpino-tokenizer">alpino-tokenizer</a></b> (🥉7 ·  ⭐ 3 · 💤) - Rust wrapper for the Alpino tokenizer. <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code>
- <b><a href="https://github.com/cmccomb/rust-stop-words">rust-stop-words</a></b> (🥉7 ·  ⭐ 3) - Common stop words in a variety of languages. <code><a href="http://bit.ly/34MBwT8">MIT</a></code>
- <b><a href="https://github.com/Garvys/rustfst">rustfst</a></b> (🥉6 ·  ⭐ 75) - Rust re-implementation of OpenFST - library for constructing,.. <code>❗Unlicensed</code>
- <b><a href="https://github.com/huggingface/spm_precompiled">spm_precompiled</a></b> (🥉6 ·  ⭐ 9) - Highly specialized crate to parse and use.. <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code>
- <b><a href="https://github.com/danieldk/sentencepiece">sentencepiece</a></b> (🥉6 ·  ⭐ 6) - Rust binding for the sentencepiece library. <code>❗Unlicensed</code>
- <b><a href="https://github.com/reinfer/blingfire-rs">blingfire-rs</a></b> (🥉5 ·  ⭐ 12 · 💀) - Rust wrapper for the BlingFire tokenization library. <code><a href="http://bit.ly/34MBwT8">MIT</a></code>
- <b><a href="https://github.com/allenai/rustberta-snli">rustberta-snli</a></b> (🥉5 ·  ⭐ 12 · 💤) - A Rust implementation of a RoBERTa classification.. <code>❗Unlicensed</code>
- <b><a href="https://github.com/bminixhofer/srx">srx</a></b> (🥉5 ·  ⭐ 4 · 💤) - A mostly compliant Rust implementation of the Segmentation Rules.. <code>❗Unlicensed</code>
- <b><a href="https://github.com/danieldk/seqalign">seqalign</a></b> (🥉5 ·  ⭐ 1) - Sequence alignments. <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code>
- <b><a href="https://github.com/ferristseng/rust-tfidf">rust-tfidf</a></b> (🥉4 ·  ⭐ 10) -  <code>❗Unlicensed</code>
- <b><a href="https://github.com/danieldk/ohnomore">ohnomore</a></b> (🥉4) - Explorations in lemmatization. <code>❗Unlicensed</code>
- <b><a href="https://github.com/Aleph-Alpha/aleph-alpha-tokenizer">aleph-alpha-tokenizer</a></b> (🥉3 ·  ⭐ 5 · 💀) - A rustic language tokenizer library inspired by.. <code>❗Unlicensed</code>
- <b><a href="https://github.com/danieldk/wordpieces">wordpieces</a></b> (🥉3 ·  ⭐ 1) - Split tokens into word pieces. <code>❗Unlicensed</code>
- <b><a href="https://github.com/andrew-johnson-4/misspeller">misspeller</a></b> (🥉3 · 💤) - Take correctly spelled words and return common spelling mistakes. <code>❗Unlicensed</code>
</details>
<br>

## Image Data

<a href="#contents"><img align="right" width="15" height="15" src="https://git.io/JtehR" alt="Back to top"></a>

_Libraries for image & video processing, manipulation, and augmentation as well as libraries for computer vision._

<details><summary><b><a href="https://github.com/rustgd/cgmath">cgmath</a></b> (🥇15 ·  ⭐ 850) - A linear algebra and mathematics library for computer graphics. <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code></summary>

- [GitHub](https://github.com/rustgd/cgmath) (👨‍💻 95 · 🔀 140 · 📋 170 - 31% open · ⏱️ 11.08.2021):

	```
	git clone https://github.com/rustgd/cgmath
	```
</details>
<details><summary><b><a href="https://github.com/twistedfall/opencv-rust">opencv-rust</a></b> (🥈14 ·  ⭐ 740) - Rust bindings for OpenCV 3 & 4. <code><a href="http://bit.ly/34MBwT8">MIT</a></code> <code><img src="🎁" style="display:inline;" width="13" height="13"></code></summary>

- [GitHub](https://github.com/twistedfall/opencv-rust) (👨‍💻 30 · 🔀 71 · 📋 220 - 9% open · ⏱️ 01.09.2021):

	```
	git clone https://github.com/twistedfall/opencv-rust
	```
</details>
<details><summary><b><a href="https://github.com/image-rs/imageproc">imageproc</a></b> (🥈14 ·  ⭐ 390) - Image processing operations. <code><a href="http://bit.ly/34MBwT8">MIT</a></code></summary>

- [GitHub](https://github.com/image-rs/imageproc) (👨‍💻 52 · 🔀 86 · 📋 150 - 36% open · ⏱️ 03.10.2021):

	```
	git clone https://github.com/image-rs/imageproc
	```
</details>
<details><summary>Show 7 hidden projects...</summary>

- <b><a href="https://github.com/EmbarkStudios/texture-synthesis">texture-synthesis</a></b> (🥈13 ·  ⭐ 1.5K) - Example-based texture synthesis written in Rust. <code>❗Unlicensed</code>
- <b><a href="https://github.com/atomashpolskiy/rustface">rustface</a></b> (🥉12 ·  ⭐ 290) - Face detection library for the Rust programming language. <code>❗Unlicensed</code>
- <b><a href="https://github.com/visioncortex/visionmagic">visionmagic</a></b> (🥉10 ·  ⭐ 32) - Collection of vision & graphics algorithms. <code>❗Unlicensed</code>
- <b><a href="https://github.com/mpizenberg/visual-odometry-rs">visual-odometry-rs</a></b> (🥉9 ·  ⭐ 29 · 💀) - Visual Odometry in Rust (vors). <code><a href="http://bit.ly/3postzC">MPL-2.0</a></code>
- <b><a href="https://github.com/jerry73204/rust-cv-convert">rust-cv-convert</a></b> (🥉9 ·  ⭐ 11) - Type conversion among popular Rust computer vision libraries. <code><a href="http://bit.ly/34MBwT8">MIT</a></code>
- <b><a href="https://github.com/rust-cv/cv">cv</a></b> (🥉8 ·  ⭐ 210) - Rust CV mono-repo. Contains pure-Rust dependencies which attempt to.. <code>❗Unlicensed</code>
- <b><a href="https://github.com/mermoldy/image-ssd">image-ssd</a></b> (🥉5 ·  ⭐ 2 · 💤) - A Rust library for object detection via SSD MobileNet. <code><a href="http://bit.ly/34MBwT8">MIT</a></code>
</details>
<br>

## Data Loading & Extraction

<a href="#contents"><img align="right" width="15" height="15" src="https://git.io/JtehR" alt="Back to top"></a>

_Libraries for loading, collecting, and extracting data from a variety of data sources and formats._

<details><summary><b><a href="https://github.com/vectordotdev/vector">vector</a></b> (🥇25 ·  ⭐ 8.1K · 📈) - A high-performance observability data pipeline. <code><a href="http://bit.ly/3postzC">MPL-2.0</a></code></summary>

- [GitHub](https://github.com/vectordotdev/vector) (👨‍💻 180 · 🔀 610 · 📥 73K · 📋 4.3K - 34% open · ⏱️ 04.10.2021):

	```
	git clone https://github.com/timberio/vector
	```
</details>
<details><summary><b><a href="https://github.com/apache/arrow">arrow</a></b> (🥇24 ·  ⭐ 8.4K) - Apache Arrow is a multi-language toolbox for accelerated data.. <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code></summary>

- [GitHub](https://github.com/apache/arrow) (👨‍💻 740 · 🔀 2K · 📦 53 · 📋 650 - 1% open · ⏱️ 04.10.2021):

	```
	git clone https://github.com/apache/arrow
	```
</details>
<details><summary><b><a href="https://github.com/datafuselabs/databend">datafuse</a></b> (🥈20 ·  ⭐ 2.2K) - An elastic and reliable Cloud Data Warehouse, offers Blazing Fast.. <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code></summary>

- [GitHub](https://github.com/datafuselabs/databend) (👨‍💻 53 · 🔀 180 · 📥 3.3K · 📋 780 - 29% open · ⏱️ 04.10.2021):

	```
	git clone https://github.com/datafuselabs/datafuse
	```
</details>
<details><summary><b><a href="https://github.com/pola-rs/polars">polars</a></b> (🥈18 ·  ⭐ 2.6K · 📈) - Fast multi-threaded DataFrame library in Rust and Python. <code><a href="http://bit.ly/34MBwT8">MIT</a></code></summary>

- [GitHub](https://github.com/pola-rs/polars) (👨‍💻 44 · 🔀 150 · 📦 4 · 📋 580 - 10% open · ⏱️ 04.10.2021):

	```
	git clone https://github.com/ritchie46/polars
	```
</details>
<details><summary><b><a href="https://github.com/apache/arrow-datafusion">arrow-datafusion</a></b> (🥈18 ·  ⭐ 1.2K · 🐣) - Apache Arrow DataFusion and Ballista query engines. <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code></summary>

- [GitHub](https://github.com/apache/arrow-datafusion) (👨‍💻 250 · 🔀 150 · 📋 580 - 43% open · ⏱️ 29.09.2021):

	```
	git clone https://github.com/apache/arrow-datafusion
	```
</details>
<details><summary><b><a href="https://github.com/getsynth/synth">synth</a></b> (🥈17 ·  ⭐ 600 · 📉) - The Declarative Data Generator. <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code></summary>

- [GitHub](https://github.com/getsynth/synth) (👨‍💻 20 · 🔀 43 · 📥 1.1K · 📋 52 - 48% open · ⏱️ 01.10.2021):

	```
	git clone https://github.com/openquery-io/synth
	```
</details>
<details><summary><b><a href="https://github.com/apache/arrow-rs">arrow-rs</a></b> (🥉16 ·  ⭐ 570 · 🐣) - Official Rust implementation of Apache Arrow. <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code></summary>

- [GitHub](https://github.com/apache/arrow-rs) (👨‍💻 270 · 🔀 120 · 📋 420 - 56% open · ⏱️ 30.09.2021):

	```
	git clone https://github.com/apache/arrow-rs
	```
</details>
<details><summary><b><a href="https://github.com/nevi-me/rust-dataframe">rust-dataframe</a></b> (🥉10 ·  ⭐ 280 · 💤) - A Rust DataFrame implementation, built on Apache Arrow. <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code></summary>

- [GitHub](https://github.com/nevi-me/rust-dataframe) (👨‍💻 4 · 🔀 20 · 📋 38 - 31% open · ⏱️ 26.10.2020):

	```
	git clone https://github.com/nevi-me/rust-dataframe
	```
</details>
<details><summary>Show 7 hidden projects...</summary>

- <b><a href="https://github.com/rayon-rs/rayon">rayon</a></b> (🥉15 ·  ⭐ 5.6K) - Rayon: A data parallelism library for Rust. <code>❗Unlicensed</code>
- <b><a href="https://github.com/BurntSushi/fst">fst</a></b> (🥉12 ·  ⭐ 1.2K) - Represent large sets and maps compactly with finite state transducers. <code>❗Unlicensed</code>
- <b><a href="https://github.com/BurntSushi/rust-csv">rust-csv</a></b> (🥉12 ·  ⭐ 1K) - A CSV parser for Rust, with Serde support. <code>❗Unlicensed</code>
- <b><a href="https://github.com/rust-lang/datafrog">datafrog</a></b> (🥉10 ·  ⭐ 440) - A lightweight Datalog engine in Rust. <code>❗Unlicensed</code>
- <b><a href="https://github.com/jerry73204/rust-tfrecord">rust-tfrecord</a></b> (🥉9 ·  ⭐ 16) - A Rust crate that reads and writes tfrecord files. <code><a href="http://bit.ly/34MBwT8">MIT</a></code>
- <b><a href="https://github.com/jerry73204/tch-serde">tch-serde</a></b> (🥉8 ·  ⭐ 4) - Serialize/Deserialize tch-rs types with serde. <code><a href="http://bit.ly/34MBwT8">MIT</a></code>
- <b><a href="https://github.com/EngineersBox/NewsAggregator">NewsAggregator</a></b> (🥉7 ·  ⭐ 1) - A fast, searchable, knowledge engine using various machine.. <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code>
</details>
<br>

## Graph Data

<a href="#contents"><img align="right" width="15" height="15" src="https://git.io/JtehR" alt="Back to top"></a>

_Libraries for graph processing, clustering, embedding, and machine learning tasks._

<details><summary><b><a href="https://github.com/alibaba/GraphScope">GraphScope</a></b> (🥇15 ·  ⭐ 990 · 📈) - GraphScope: A One-Stop Large-Scale Graph Computing System.. <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code></summary>

- [GitHub](https://github.com/alibaba/GraphScope) (👨‍💻 22 · 🔀 110 · 📥 9 · 📋 340 - 29% open · ⏱️ 30.09.2021):

	```
	git clone https://github.com/alibaba/GraphScope
	```
</details>
<details><summary>Show 3 hidden projects...</summary>

- <b><a href="https://github.com/petgraph/petgraph">petgraph</a></b> (🥇15 ·  ⭐ 1.5K) - Graph data structure library for Rust. <code>❗Unlicensed</code>
- <b><a href="https://github.com/sreeise/graph-rs">graph-rs</a></b> (🥉14 ·  ⭐ 24) - Graph API client writen in Rust. <code><a href="http://bit.ly/34MBwT8">MIT</a></code>
- <b><a href="https://github.com/purpleprotocol/graphlib">graphlib</a></b> (🥉13 ·  ⭐ 160 · 💀) - Simple but powerful graph library for Rust. <code><a href="http://bit.ly/34MBwT8">MIT</a></code>
</details>
<br>

## Model Interpretability

<a href="#contents"><img align="right" width="15" height="15" src="https://git.io/JtehR" alt="Back to top"></a>

_Libraries to visualize, explain, debug, evaluate, and interpret machine learning models._

<details><summary>Show 1 hidden projects...</summary>

- <b><a href="https://github.com/benjarison/eval-metrics">eval-metrics</a></b> (🥇8 ·  ⭐ 2) - Evaluation metrics for machine learning. <code>❗Unlicensed</code>
</details>
<br>

## MLOps

<a href="#contents"><img align="right" width="15" height="15" src="https://git.io/JtehR" alt="Back to top"></a>

_Libraries to design workflows, deploy, test, and maintain machine learning pipelines._

<details><summary>Show 1 hidden projects...</summary>

- <b><a href="https://github.com/h2oai/h2o-kubernetes">h2o-kubernetes</a></b> (🥇7 ·  ⭐ 13 · 💤) - H2O Open Source Kubernetes operator and a command-line.. <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code>
</details>
<br>

## Applications

<a href="#contents"><img align="right" width="15" height="15" src="https://git.io/JtehR" alt="Back to top"></a>

_ML, NLP, or relevant applications._

<details><summary><b><a href="https://github.com/meilisearch/MeiliSearch">MeiliSearch</a></b> (🥇20 ·  ⭐ 19K · ➕) - Powerful, fast, and an easy to use search engine. <code><a href="http://bit.ly/34MBwT8">MIT</a></code></summary>

- [GitHub](https://github.com/meilisearch/MeiliSearch) (👨‍💻 65 · 🔀 590 · 📥 19K · 📋 720 - 6% open · ⏱️ 04.10.2021):

	```
	git clone https://github.com/meilisearch/MeiliSearch
	```
</details>
<details><summary><b><a href="https://github.com/valeriansaliou/sonic">sonic</a></b> (🥈18 ·  ⭐ 12K · ➕) - Fast, lightweight & schema-less search backend. An alternative to.. <code><a href="http://bit.ly/3postzC">MPL-2.0</a></code></summary>

- [GitHub](https://github.com/valeriansaliou/sonic) (👨‍💻 28 · 🔀 390 · 📥 560 · 📋 220 - 19% open · ⏱️ 22.07.2021):

	```
	git clone https://github.com/valeriansaliou/sonic
	```
</details>
<details><summary><b><a href="https://github.com/tantivy-search/tantivy">tantivy</a></b> (🥈17 ·  ⭐ 5.3K · ➕) - Tantivy is a full-text search engine library inspired by Apache.. <code><a href="http://bit.ly/34MBwT8">MIT</a></code></summary>

- [GitHub](https://github.com/tantivy-search/tantivy) (👨‍💻 93 · 🔀 320 · 📋 560 - 23% open · ⏱️ 01.10.2021):

	```
	git clone https://github.com/tantivy-search/tantivy
	```
</details>
<details><summary><b><a href="https://github.com/qdrant/qdrant">qdrant</a></b> (🥈16 ·  ⭐ 610 · ➕) - Qdrant - vector similarity search engine with extended filtering.. <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code></summary>

- [GitHub](https://github.com/qdrant/qdrant) (👨‍💻 10 · 🔀 38 · 📋 44 - 52% open · ⏱️ 25.09.2021):

	```
	git clone https://github.com/qdrant/qdrant
	```
</details>
<details><summary><b><a href="https://github.com/bayard-search/bayard">bayard</a></b> (🥉15 ·  ⭐ 1.5K · 💤) - A full-text search and indexing server written in Rust. <code><a href="http://bit.ly/34MBwT8">MIT</a></code></summary>

- [GitHub](https://github.com/bayard-search/bayard) (👨‍💻 12 · 🔀 58 · 📋 40 - 30% open · ⏱️ 22.02.2021):

	```
	git clone https://github.com/bayard-search/bayard
	```
</details>
<details><summary><b><a href="https://github.com/toshi-search/Toshi">Toshi</a></b> (🥉14 ·  ⭐ 3.3K · ➕) - A full-text search engine in rust. <code><a href="http://bit.ly/34MBwT8">MIT</a></code></summary>

- [GitHub](https://github.com/toshi-search/Toshi) (👨‍💻 16 · 🔀 96 · 📋 110 - 8% open · ⏱️ 14.09.2021):

	```
	git clone https://github.com/toshi-search/Toshi
	```
</details>
<details><summary><b><a href="https://github.com/meilisearch/milli">milli</a></b> (🥉13 ·  ⭐ 170 · ➕) - Search through millions of documents in milliseconds. <code><a href="http://bit.ly/34MBwT8">MIT</a></code></summary>

- [GitHub](https://github.com/meilisearch/milli) (👨‍💻 12 · 🔀 18 · 📋 120 - 6% open · ⏱️ 03.10.2021):

	```
	git clone https://github.com/meilisearch/milli
	```
</details>
<details><summary><b><a href="https://github.com/hora-search/hora">hora-hora</a></b> (🥉11 ·  ⭐ 2.1K · 🐣) - efficient approximate nearest neighbor search algorithm.. <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code></summary>

- [GitHub](https://github.com/hora-search/hora) (👨‍💻 5 · 🔀 33 · 📋 20 - 55% open · ⏱️ 14.09.2021):

	```
	git clone https://github.com/hora-search/hora
	```
</details>
<details><summary>Show 3 hidden projects...</summary>

- <b><a href="https://github.com/zombodb/zombodb">zombodb</a></b> (🥇20 ·  ⭐ 3.7K · ➕) - Making Postgres and Elasticsearch work together like it's.. <code>❗Unlicensed</code>
- <b><a href="https://github.com/quickwit-inc/quickwit">quickwit</a></b> (🥉12 ·  ⭐ 800 · 🐣) - Quickwit is a fast and highly reliable distributed search.. <code>❗Unlicensed</code>
- <b><a href="https://github.com/googleprojectzero/weggli">weggli</a></b> (🥉9 ·  ⭐ 580 · 🐣) - weggli is a fast and robust semantic search tool for C and C++.. <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code>
</details>

---

## Related Resources

- [**best-of-ml-python**](https://github.com/ml-tooling/best-of-ml-python): A ranked list of awesome machine learning Python libraries.
- [**best-of-ml-julia**](https://github.com/e-tony/best-of-ml-julia): A ranked list of awesome machine learning Julia libraries.

## Contribution

Contributions are encouraged and always welcome! If you like to add or update projects, choose one of the following ways:

- Open an issue by selecting one of the provided categories from the [issue page](https://github.com/e-tony/best-of-ml-rust/issues/new/choose) and fill in the requested information.
- Modify the [projects.yaml](https://github.com/e-tony/best-of-ml-rust/blob/main/projects.yaml) with your additions or changes, and submit a pull request. This can also be done directly via the [Github UI](https://github.com/e-tony/best-of-ml-rust/edit/main/projects.yaml).

If you like to contribute to or share suggestions regarding the project metadata collection or markdown generation, please refer to the [best-of-generator](https://github.com/best-of-lists/best-of-generator) repository. If you like to create your own best-of list, we recommend to follow [this guide](https://github.com/best-of-lists/best-of/blob/main/create-best-of-list.md).

For more information on how to add or update projects, please read the [contribution guidelines](https://github.com/e-tony/best-of-ml-rust/blob/main/CONTRIBUTING.md). By participating in this project, you agree to abide by its [Code of Conduct](https://github.com/e-tony/best-of-ml-rust/blob/main/.github/CODE_OF_CONDUCT.md).

## License

[![CC0](https://mirrors.creativecommons.org/presskit/buttons/88x31/svg/by-sa.svg)](https://creativecommons.org/licenses/by-sa/4.0/)
